import React, { createContext, useEffect, useState } from 'react';
// import { useEffect } from 'react';
import { useParams } from 'react-router-dom';
import { connect } from 'react-redux';
// import { store } from '../../redux';
// import { useState } from 'react';

import { Box, Container, Divider } from '@mui/material';

import BasicCard from './userData';
import { actionFindUserOne, actionFullUserFindOne } from '../../redux/thunks';

import { StandardImageList, СStandardImageList } from './gallery';

export const EditProfile = createContext()

function User({ user = {}, loadUser }) {
    // console.log('user: ', user)

    const [isEditProfile, setIsEditProfile] = useState(false)
    // console.log('isEditProfile: ', isEditProfile)

    const { userId } = useParams()
    useEffect(() => { loadUser(userId) }, [userId])

    return (
        // <React.Fragment>
        <EditProfile.Provider value={[isEditProfile, setIsEditProfile]}>
            <Box
                sx={{
                    margin: "20px 50px"
                }}
            >
                <BasicCard userData={user} />
            </Box>

            <Divider />

            <Box>
                <СStandardImageList />
            </Box>
            {/* </React.Fragment > */}
        </EditProfile.Provider >
    );
}

export const CUser = connect(state => ({ user: state?.promise?.UserFindOne?.payload }), { loadUser: actionFullUserFindOne })(User)





















// export const CUser = connect(state => ({ user: state?.promise?.UserFindOne?.payload }), { loadUser: actionFullUserFindOne })(User)

// export const CUser = connect(state => ({ user: state?.promise }), { loadUser: actionFullUserFindOne })(User)